#!/usr/bin/perl
#
# This code is distributed under the terms of the GPL
#
# (c) Tiago Freitas Leal
# (c) Toby Long-Leather 2005

require '/var/smoothwall/mods/multi-ip-standalone/modlib.pl';

# # # # # # # # # # # # # # # # # # #
# check for existing installations  #
# # # # # # # # # # # # # # # # # # #

if (-e "/var/smoothwall/mods/multi-ip-standalone/installed") {
	if (&installed ("/var/smoothwall/mods/multi-ip-standalone/installed", "# Multiple IP Addresses Standalone v1.0") ||
	    &installed ("/var/smoothwall/mods/multi-ip-standalone/installed", "# Multiple IP Addresses Standalone v1.1")) {
		print "\nPlease remove previous version of Multiple IP Addresses Standalone\n";
		print "Note - Run uninstall.pl script.\n \n";
		exit;
	}
}

# # # # # # # # # # # #
# handle file copying #
# # # # # # # # # # # #

#	$storebkp =	where to store backup of the files that are changed by your mod
#	$moddir =	where your mod files are
#	$wkdir =	where you are changing files (backup from and copy to)
#
#	backupinstall ($file, $wkdir, $storebkp, $moddir);
#	backup ($file, $wkdir, $storebkp);
#	install ($file, $wkdir, $moddir);
#	uninstallrestore ($file, $wkdir, $storebkp);
#	uninstall ($file , $wkdir);
#
#	installed ($file, $string);
#
#	search for $string into $file => 1 found / 0 not found

my $bkp = '/var/smoothwall/mods/multi-ip-standalone/backup';

print "Creating backups ...\n";

$dir = '/var/smoothwall/main/ui';
&backup('alertboxes.en.pl', $dir, $bkp);

$dir = '/var/smoothwall';
&backup('header.pl', $dir, $bkp);

$dir = '/var/smoothwall/langs';
&backup('base.pl', $dir, $bkp);

$dir = '/home/httpd/cgi-bin';
&backup('multiip.cgi', $dir, $bkp) if (-e "$dir/multiip.cgi");

$dir = '/home/httpd/html/help';
&backup('multiip.cgi.html.en', $dir, $bkp) if (-e "$dir/multiip.cgi.html.en");

$dir = '/usr/local/bin';
&backup('restartmultiip', $dir, $bkp) if (-e "$dir/restartmultiip");
&backup('restartnetwork', $dir, $bkp) if (-e "$dir/restartnetwork");
&backup('setxtaccess', $dir, $bkp) if (-e "$dir/setxtaccess");

$dir = '/etc/rc.d';
&backup('rc.netaddress.down', $dir, $bkp);
&backup('rc.netaddress.up', $dir, $bkp);
&backup('rc.firewall.up', $dir, $bkp);
&backup('rc.updatered', $dir, $bkp);

my $mod = '/var/smoothwall/mods/multi-ip-standalone/modfiles';

print "Installing new files ...\n";

$dir = '/home/httpd/cgi-bin';
&install ('multiip.cgi', $dir, $mod);

$dir = '/home/httpd/html/help';
&install ('multiip.cgi.html.en', $dir, $mod);

$dir = '/usr/local/bin';
&install ('restartmultiip', $dir, $mod);
&install ('restartnetwork', $dir, $mod);
&install ('setxtaccess', $dir, $mod);

# # # # # # # # # # # #
# handle permissions  #
# # # # # # # # # # # #

# Change owner of /var/smoothwall/ethernet so that the web UI can write files there
system ("/bin/chown nobody.nobody /var/smoothwall/ethernet");

# Set owner and mode for /usr/local/bin files
system ("/bin/chown root.nobody /usr/local/bin/restartmultiip");
system ("/bin/chmod u+s /usr/local/bin/restartmultiip");
system ("/bin/chown root.nobody /usr/local/bin/restartnetwork");
system ("/bin/chmod u+s /usr/local/bin/restartnetwork");
system ("/bin/chown root.nobody /usr/local/bin/setxtaccess");
system ("/bin/chmod u+s /usr/local/bin/setxtaccess");

# # # # # # # # # # # #
# handle file editing #
# # # # # # # # # # # #

my $param = '/var/smoothwall/mods/multi-ip-standalone/params';

&easymod ("/var/smoothwall/main/ui/alertboxes.en.pl", "$param/alertboxes.en.pl-1.0-1.s", '2', "$param/alertboxes.en.pl-1.0-1.r");

&easymod ("/var/smoothwall/header.pl", "$param/header.pl-1.0-1.s", '0', "$param/header.pl-1.0-1.r");

&easymod ("/var/smoothwall/langs/base.pl", "$param/base.pl-1.0-1.s", '2', "$param/base.pl-1.0-1.r");

&easymod ("/home/httpd/cgi-bin/.htaccess", "$param/.htaccess-1.0-1.s", '0', "$param/.htaccess-1.0-1.r");

&easymod ("/etc/rc.d/rc.netaddress.down", "$param/rc.netaddress.down-1.0-1.s", '0', "$param/rc.netaddress.down-1.0-1.r");
&easymod ("/etc/rc.d/rc.netaddress.down", "$param/rc.netaddress.down-1.0-2.s", '0', "$param/rc.netaddress.down-1.0-2.r");
&easymod ("/etc/rc.d/rc.netaddress.down", "$param/rc.netaddress.down-1.0-3.s", '0', "$param/rc.netaddress.down-1.0-3.r");
&easymod ("/etc/rc.d/rc.netaddress.down", "$param/rc.netaddress.down-1.0-4.s", '0', "$param/rc.netaddress.down-1.0-4.r");

&easymod ("/etc/rc.d/rc.netaddress.up", "$param/rc.netaddress.up-1.0-1.s", '0', "$param/rc.netaddress.up-1.0-1.r");
&easymod ("/etc/rc.d/rc.netaddress.up", "$param/rc.netaddress.up-1.0-2.s", '0', "$param/rc.netaddress.up-1.0-2.r");
&easymod ("/etc/rc.d/rc.netaddress.up", "$param/rc.netaddress.up-1.0-3.s", '0', "$param/rc.netaddress.up-1.0-3.r");
&easymod ("/etc/rc.d/rc.netaddress.up", "$param/rc.netaddress.up-1.0-4.s", '0', "$param/rc.netaddress.up-1.0-4.r");

&easymod ("/etc/rc.d/rc.firewall.up", "$param/rc.firewall.up-1.0-1.s", '0', "$param/rc.firewall.up-1.0-1.r");
&easymod ("/etc/rc.d/rc.firewall.up", "$param/rc.firewall.up-1.0-2.s", '0', "$param/rc.firewall.up-1.0-2.r");

&easymod ("/etc/rc.d/rc.updatered", "$param/rc.updatered-1.0-1.s", '0', "$param/rc.updatered-1.0-1.r");
&easymod ("/etc/rc.d/rc.updatered", "$param/rc.updatered-1.0-2.s", '0', "$param/rc.updatered-1.0-2.r");

# # # # # # # # # # # #
# handle file linking #
# # # # # # # # # # # #
system("cd /home/httpd/html/ui/assets/3.6/img/pagetitles && /bin/ln -sf title-networking.png page-multiip.png");


$mod = '/var/smoothwall/mods/multi-ip-standalone/modfiles';
$dir = '/var/smoothwall/mods/multi-ip-standalone';
&install ('installed', $dir, $mod);

print "Restarting network...";
system("/usr/local/bin/restartnetwork");
print "\nDone\n\n";

# # # #
# end #
# # # #
