#!/usr/bin/perl
#
# This code is distributed under the terms of the GPL
#
# (c) Tiago Freitas Leal
# (c) Toby Long-Leather 2005

require '/var/smoothwall/mods/multi-ip-standalone/modlib.pl';

# # # # # # # # # # # # # # # # # # #
# check for existing installations  #
# # # # # # # # # # # # # # # # # # #

if (-e "/var/smoothwall/mods/multi-ip-standalone/installed") {
	if (! (&installed ("/var/smoothwall/mods/multi-ip-standalone/installed", "# Multiple IP Addresses Standalone v1.0") ||
	       &installed ("/var/smoothwall/mods/multi-ip-standalone/installed", "# Multiple IP Addresses Standalone v1.1"))) {
		print "\nMultiple IP Addresses Standalone is not installed - cannot uninstall\n";
		exit;
	}
}

# # # # # # # # # # # #
# handle file copying #
# # # # # # # # # # # #

#	$storebkp =	where to store backup of the files that are changed by your mod
#	$moddir =	where your mod files are
#	$wkdir =	where you are changing files (backup from and copy to)
#
#	backupinstall ($file, $wkdir, $storebkp, $moddir);
#	backup ($file, $wkdir, $storebkp);
#	install ($file, $wkdir, $moddir);
#	uninstallrestore ($file, $wkdir, $storebkp);
#	uninstall ($file , $wkdir);
#
#	installed ($file, $string);
#
#	search for $string into $file => 1 found / 0 not found

my $bkp = '/var/smoothwall/mods/multi-ip-standalone/backup';

$dir = '/home/httpd/cgi-bin';
&uninstallrestore('multiip.cgi', $dir, $bkp) if (-e "$bkp/multiip.cgi");

$dir = '/home/httpd/html/help';
&uninstallrestore('multiip.cgi.html.en', $dir, $bkp) if (-e "$bkp/multiip.cgi.html.en");

$dir = '/usr/local/bin';
&uninstallrestore('restartmultiip', $dir, $bkp) if (-e "$bkp/restartmultiip");
&uninstallrestore('restartnetwork', $dir, $bkp) if (-e "$bkp/restartnetwork");
&uninstallrestore('setxtaccess', $dir, $bkp) if (-e "$bkp/setxtaccess");

# # # # # # # # # # # #
# handle file editing #
# # # # # # # # # # # #

my $param = '/var/smoothwall/mods/multi-ip-standalone/params';

&easymod ("/var/smoothwall/main/ui/alertboxes.en.pl", "$param/alertboxes.en.pl-1.0-1.r", (`grep -c ".*" $param/alertboxes.en.pl-1.0-1.r` - 2), "/dev/null");

&easymod ("/var/smoothwall/header.pl", "$param/header.pl-1.0-1.r", `grep -c ".*" $param/header.pl-1.0-1.r`, "/dev/null");

&easymod ("/var/smoothwall/langs/base.pl", "$param/base.pl-1.0-1.r", (`grep -c ".*" $param/base.pl-1.0-1.r` - 2), "/dev/null");

&easymod ("/etc/rc.d/rc.netaddress.down", "$param/rc.netaddress.down-1.0-1.r", `grep -c ".*" $param/rc.netaddress.down-1.0-1.r`, "/dev/null");
&easymod ("/etc/rc.d/rc.netaddress.down", "$param/rc.netaddress.down-1.0-2.r", `grep -c ".*" $param/rc.netaddress.down-1.0-2.r`, "/dev/null");
&easymod ("/etc/rc.d/rc.netaddress.down", "$param/rc.netaddress.down-1.0-3.r", `grep -c ".*" $param/rc.netaddress.down-1.0-3.r`, "/dev/null");
&easymod ("/etc/rc.d/rc.netaddress.down", "$param/rc.netaddress.down-1.0-4.r", `grep -c ".*" $param/rc.netaddress.down-1.0-4.r`, "/dev/null");

&easymod ("/etc/rc.d/rc.netaddress.up", "$param/rc.netaddress.up-1.0-1.r", `grep -c ".*" $param/rc.netaddress.up-1.0-1.r`, "/dev/null");
&easymod ("/etc/rc.d/rc.netaddress.up", "$param/rc.netaddress.up-1.0-2.r", `grep -c ".*" $param/rc.netaddress.up-1.0-2.r`, "/dev/null");
&easymod ("/etc/rc.d/rc.netaddress.up", "$param/rc.netaddress.up-1.0-3.r", `grep -c ".*" $param/rc.netaddress.up-1.0-3.r`, "/dev/null");
&easymod ("/etc/rc.d/rc.netaddress.up", "$param/rc.netaddress.up-1.0-4.r", `grep -c ".*" $param/rc.netaddress.up-1.0-4.r`, "/dev/null");

&easymod ("/etc/rc.d/rc.firewall.up", "$param/rc.firewall.up-1.0-1.r", `grep -c ".*" $param/rc.firewall.up-1.0-1.r`, "/dev/null");
&easymod ("/etc/rc.d/rc.firewall.up", "$param/rc.firewall.up-1.0-2.r", `grep -c ".*" $param/rc.firewall.up-1.0-2.r`, "/dev/null");

&easymod ("/etc/rc.d/rc.updatered", "$param/rc.updatered-1.0-1.r", `grep -c ".*" $param/rc.updatered-1.0-1.r`, "/dev/null");
&easymod ("/etc/rc.d/rc.updatered", "$param/rc.updatered-1.0-2.r", `grep -c ".*" $param/rc.updatered-1.0-2.r`, "/dev/null");

# # # # # # # # # # # #
# handle file linking #
# # # # # # # # # # # #

$dir = '/var/smoothwall/mods/multi-ip-standalone';
&uninstall ("installed", $dir);

print "Done\n\nYou must reboot to make sure any network changes take effect\n\n";

# # # #
# end #
# # # #
